

#ifndef TENSOR_HEADER
#define TENSOR_HEADER

struct Dimension {
  int num_dims;
  size_t *dim_sizes;
};

enum data_location_t { HOST, DEVICE };

struct Tensor {
  int data_type;
  int cur_type;
  int data_format;
  data_location_t  data_placement; // Maintains the location of the tensor {host, device...}
  void *host_data;
  void *gpu_data;       // Pointer to GPU FP32 data
  void *gpu_half_data;  // Pointer to GPU FP16 data
  size_t num_elems;     // Total elements
  size_t size_in_bytes; // Total size in bytes
  struct Dimension dims;
};

// NOTE: Currently only NCHW is supported due to limited cuDNN support
enum Tensor_format_t { nchw, nhwc };


#endif
